"""Add resource tables and meta-paths to workflow executions

Revision ID: 410efa47f94c
Revises: e161adcdd651
Create Date: 2023-12-04 10:23:44.095178

"""

import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import mysql

# revision identifiers, used by Alembic.
revision = "410efa47f94c"
down_revision = "e161adcdd651"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "resource",
        sa.Column("resource_id", sa.BINARY(length=16), nullable=False),
        sa.Column("name", sa.String(length=32), nullable=False),
        sa.Column("short_description", sa.String(length=264), nullable=False),
        sa.Column("source", sa.String(length=264), nullable=False),
        sa.Column("maintainer_id", sa.String(length=64), nullable=True),
        sa.Column("created_at", sa.Integer(), server_default=sa.text("(UNIX_TIMESTAMP())"), nullable=False),
        sa.Column("updated_at", sa.Integer(), server_default=sa.text("(UNIX_TIMESTAMP())"), nullable=False),
        sa.ForeignKeyConstraint(["maintainer_id"], ["user.uid"], ondelete="SET NULL"),
        sa.PrimaryKeyConstraint("resource_id"),
        sa.UniqueConstraint("name"),
    )
    op.create_index(op.f("ix_resource_resource_id"), "resource", ["resource_id"], unique=True)
    op.create_table(
        "resource_version",
        sa.Column("resource_version_id", sa.BINARY(length=16), nullable=False),
        sa.Column("release", sa.String(length=32), nullable=False),
        sa.Column(
            "status",
            mysql.ENUM(
                "RESOURCE_REQUESTED",
                "SYNC_REQUESTED",
                "SYNCHRONIZING",
                "SYNCHRONIZED",
                "LATEST",
                "DENIED",
                "CLUSTER_DELETED",
                "S3_DELETED",
            ),
            nullable=False,
        ),
        sa.Column("resource_id", sa.BINARY(length=16), nullable=False),
        sa.Column("previous_resource_version_id", sa.BINARY(length=16), nullable=True),
        sa.Column("created_at", sa.Integer(), server_default=sa.text("(UNIX_TIMESTAMP())"), nullable=False),
        sa.Column("updated_at", sa.Integer(), server_default=sa.text("(UNIX_TIMESTAMP())"), nullable=False),
        sa.ForeignKeyConstraint(
            ["previous_resource_version_id"], ["resource_version.resource_version_id"], ondelete="SET NULL"
        ),
        sa.ForeignKeyConstraint(["resource_id"], ["resource.resource_id"], ondelete="CASCADE"),
        sa.PrimaryKeyConstraint("resource_version_id"),
    )
    op.create_index(
        op.f("ix_resource_version_resource_version_id"), "resource_version", ["resource_version_id"], unique=True
    )
    op.drop_column("workflow", "credentials_username")
    op.add_column("workflow_execution", sa.Column("debug_path", sa.String(length=1024), nullable=True))
    op.add_column("workflow_execution", sa.Column("logs_path", sa.String(length=1024), nullable=True))
    op.add_column("workflow_execution", sa.Column("provenance_path", sa.String(length=1024), nullable=True))
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column("workflow_execution", "provenance_path")
    op.drop_column("workflow_execution", "logs_path")
    op.drop_column("workflow_execution", "debug_path")
    op.add_column("workflow", sa.Column("credentials_username", mysql.VARCHAR(length=128), nullable=True))
    op.drop_index(op.f("ix_resource_version_resource_version_id"), table_name="resource_version")
    op.drop_table("resource_version")
    op.drop_index(op.f("ix_resource_resource_id"), table_name="resource")
    op.drop_table("resource")
    # ### end Alembic commands ###
